(* This file is generated by Why3's Coq driver *)
(* Beware! Only edit allowed sections below    *)
Require Import BuiltIn.
Require BuiltIn.
Require int.Int.
Require list.List.
Require list.Length.
Require list.Mem.
Require list.Append.
Require list.Reverse.
Require list.NumOcc.

(* Why3 assumption *)
Definition unit := unit.

(* Why3 assumption *)
Inductive ref (a:Type) :=
  | mk_ref : a -> ref a.
Axiom ref_WhyType : forall (a:Type) {a_WT:WhyType a}, WhyType (ref a).
Existing Instance ref_WhyType.
Implicit Arguments mk_ref [[a]].

(* Why3 assumption *)
Definition contents {a:Type} {a_WT:WhyType a} (v:(ref a)): a :=
  match v with
  | (mk_ref x) => x
  end.

Axiom set : forall (a:Type), Type.
Parameter set_WhyType : forall (a:Type) {a_WT:WhyType a}, WhyType (set a).
Existing Instance set_WhyType.

Parameter mem: forall {a:Type} {a_WT:WhyType a}, a -> (set a) -> Prop.

(* Why3 assumption *)
Definition infix_eqeq {a:Type} {a_WT:WhyType a} (s1:(set a)) (s2:(set
  a)): Prop := forall (x:a), (mem x s1) <-> (mem x s2).

Axiom extensionality : forall {a:Type} {a_WT:WhyType a}, forall (s1:(set a))
  (s2:(set a)), (infix_eqeq s1 s2) -> (s1 = s2).

(* Why3 assumption *)
Definition subset {a:Type} {a_WT:WhyType a} (s1:(set a)) (s2:(set
  a)): Prop := forall (x:a), (mem x s1) -> (mem x s2).

Axiom subset_refl : forall {a:Type} {a_WT:WhyType a}, forall (s:(set a)),
  (subset s s).

Axiom subset_trans : forall {a:Type} {a_WT:WhyType a}, forall (s1:(set a))
  (s2:(set a)) (s3:(set a)), (subset s1 s2) -> ((subset s2 s3) -> (subset s1
  s3)).

Parameter empty: forall {a:Type} {a_WT:WhyType a}, (set a).

(* Why3 assumption *)
Definition is_empty {a:Type} {a_WT:WhyType a} (s:(set a)): Prop :=
  forall (x:a), ~ (mem x s).

Axiom empty_def1 : forall {a:Type} {a_WT:WhyType a}, (is_empty (empty : (set
  a))).

Axiom mem_empty : forall {a:Type} {a_WT:WhyType a}, forall (x:a), ~ (mem x
  (empty : (set a))).

Parameter add: forall {a:Type} {a_WT:WhyType a}, a -> (set a) -> (set a).

Axiom add_def1 : forall {a:Type} {a_WT:WhyType a}, forall (x:a) (y:a),
  forall (s:(set a)), (mem x (add y s)) <-> ((x = y) \/ (mem x s)).

Parameter remove: forall {a:Type} {a_WT:WhyType a}, a -> (set a) -> (set a).

Axiom remove_def1 : forall {a:Type} {a_WT:WhyType a}, forall (x:a) (y:a)
  (s:(set a)), (mem x (remove y s)) <-> ((~ (x = y)) /\ (mem x s)).

Axiom add_remove : forall {a:Type} {a_WT:WhyType a}, forall (x:a) (s:(set
  a)), (mem x s) -> ((add x (remove x s)) = s).

Axiom remove_add : forall {a:Type} {a_WT:WhyType a}, forall (x:a) (s:(set
  a)), ((remove x (add x s)) = (remove x s)).

Axiom subset_remove : forall {a:Type} {a_WT:WhyType a}, forall (x:a) (s:(set
  a)), (subset (remove x s) s).

Parameter union: forall {a:Type} {a_WT:WhyType a}, (set a) -> (set a) -> (set
  a).

Axiom union_def1 : forall {a:Type} {a_WT:WhyType a}, forall (s1:(set a))
  (s2:(set a)) (x:a), (mem x (union s1 s2)) <-> ((mem x s1) \/ (mem x s2)).

Parameter inter: forall {a:Type} {a_WT:WhyType a}, (set a) -> (set a) -> (set
  a).

Axiom inter_def1 : forall {a:Type} {a_WT:WhyType a}, forall (s1:(set a))
  (s2:(set a)) (x:a), (mem x (inter s1 s2)) <-> ((mem x s1) /\ (mem x s2)).

Parameter diff: forall {a:Type} {a_WT:WhyType a}, (set a) -> (set a) -> (set
  a).

Axiom diff_def1 : forall {a:Type} {a_WT:WhyType a}, forall (s1:(set a))
  (s2:(set a)) (x:a), (mem x (diff s1 s2)) <-> ((mem x s1) /\ ~ (mem x s2)).

Axiom subset_diff : forall {a:Type} {a_WT:WhyType a}, forall (s1:(set a))
  (s2:(set a)), (subset (diff s1 s2) s1).

Parameter choose: forall {a:Type} {a_WT:WhyType a}, (set a) -> a.

Axiom choose_def : forall {a:Type} {a_WT:WhyType a}, forall (s:(set a)),
  (~ (is_empty s)) -> (mem (choose s) s).

Parameter cardinal: forall {a:Type} {a_WT:WhyType a}, (set a) -> Z.

Axiom cardinal_nonneg : forall {a:Type} {a_WT:WhyType a}, forall (s:(set a)),
  (0%Z <= (cardinal s))%Z.

Axiom cardinal_empty : forall {a:Type} {a_WT:WhyType a}, forall (s:(set a)),
  ((cardinal s) = 0%Z) <-> (is_empty s).

Axiom cardinal_add : forall {a:Type} {a_WT:WhyType a}, forall (x:a),
  forall (s:(set a)), (~ (mem x s)) -> ((cardinal (add x
  s)) = (1%Z + (cardinal s))%Z).

Axiom cardinal_remove : forall {a:Type} {a_WT:WhyType a}, forall (x:a),
  forall (s:(set a)), (mem x s) -> ((cardinal s) = (1%Z + (cardinal (remove x
  s)))%Z).

Axiom cardinal_subset : forall {a:Type} {a_WT:WhyType a}, forall (s1:(set a))
  (s2:(set a)), (subset s1 s2) -> ((cardinal s1) <= (cardinal s2))%Z.

Axiom subset_eq : forall {a:Type} {a_WT:WhyType a}, forall (s1:(set a))
  (s2:(set a)), (subset s1 s2) -> (((cardinal s1) = (cardinal s2)) ->
  (infix_eqeq s1 s2)).

Axiom cardinal1 : forall {a:Type} {a_WT:WhyType a}, forall (s:(set a)),
  ((cardinal s) = 1%Z) -> forall (x:a), (mem x s) -> (x = (choose s)).

(* Why3 assumption *)
Fixpoint elements {a:Type} {a_WT:WhyType a} (l:(list a)) {struct l}: (set
  a) :=
  match l with
  | Init.Datatypes.nil => (empty : (set a))
  | (Init.Datatypes.cons x r) => (add x (elements r))
  end.

Axiom elements_mem : forall {a:Type} {a_WT:WhyType a}, forall (x:a)
  (l:(list a)), (list.Mem.mem x l) <-> (mem x (elements l)).

(* Why3 assumption *)
Inductive t (a:Type) :=
  | mk_t : (list a) -> t a.
Axiom t_WhyType : forall (a:Type) {a_WT:WhyType a}, WhyType (t a).
Existing Instance t_WhyType.
Implicit Arguments mk_t [[a]].

(* Why3 assumption *)
Definition elts {a:Type} {a_WT:WhyType a} (v:(t a)): (list a) :=
  match v with
  | (mk_t x) => x
  end.

(* Why3 assumption *)
Definition length {a:Type} {a_WT:WhyType a} (s:(t a)): Z :=
  (list.Length.length (elts s)).

Axiom vertex : Type.
Parameter vertex_WhyType : WhyType vertex.
Existing Instance vertex_WhyType.

Parameter vertices: (set vertex).

Parameter successors: vertex -> (set vertex).

Axiom successors_vertices : forall (x:vertex), (mem x vertices) -> (subset
  (successors x) vertices).

(* Why3 assumption *)
Definition edge (x:vertex) (y:vertex): Prop := (mem x vertices) /\ (mem y
  (successors x)).

(* Why3 assumption *)
Inductive path: vertex -> (list vertex) -> vertex -> Prop :=
  | Path_empty : forall (x:vertex), (path x Init.Datatypes.nil x)
  | Path_cons : forall (x:vertex) (y:vertex) (z:vertex) (l:(list vertex)),
      (edge x y) -> ((path y l z) -> (path x (Init.Datatypes.cons x l) z)).

Axiom path_right_extension : forall (x:vertex) (y:vertex) (z:vertex)
  (l:(list vertex)), (path x l y) -> ((edge y z) -> (path x
  (Init.Datatypes.app l (Init.Datatypes.cons y Init.Datatypes.nil)) z)).

Axiom path_right_inversion : forall (x:vertex) (z:vertex) (l:(list vertex)),
  (path x l z) -> (((x = z) /\ (l = Init.Datatypes.nil)) \/ exists y:vertex,
  exists l':(list vertex), (path x l' y) /\ ((edge y z) /\
  (l = (Init.Datatypes.app l' (Init.Datatypes.cons y Init.Datatypes.nil))))).

Axiom path_trans : forall (x:vertex) (y:vertex) (z:vertex) (l1:(list vertex))
  (l2:(list vertex)), (path x l1 y) -> ((path y l2 z) -> (path x
  (Init.Datatypes.app l1 l2) z)).

Axiom empty_path : forall (x:vertex) (y:vertex), (path x Init.Datatypes.nil
  y) -> (x = y).

Axiom path_decomposition : forall (x:vertex) (y:vertex) (z:vertex)
  (l1:(list vertex)) (l2:(list vertex)), (path x
  (Init.Datatypes.app l1 (Init.Datatypes.cons y l2)) z) -> ((path x l1 y) /\
  (path y (Init.Datatypes.cons y l2) z)).

(* Why3 assumption *)
Definition white_vertex (x:vertex) (v:(set vertex)): Prop := ~ (mem x v).

(* Why3 assumption *)
Definition whitepath (x:vertex) (l:(list vertex)) (z:vertex) (v:(set
  vertex)): Prop := (path x l z) /\ ((forall (y:vertex), (list.Mem.mem y
  l) -> (white_vertex y v)) /\ (white_vertex z v)).

Axiom whitepath_id : forall (x:vertex) (v:(set vertex)), (~ (mem x v)) ->
  (whitepath x Init.Datatypes.nil x v).

Axiom whitepath_covar : forall (v:(set vertex)) (v':(set vertex)) (x:vertex)
  (l:(list vertex)) (y:vertex), (subset v v') -> ((whitepath x l y v') ->
  (whitepath x l y v)).

Axiom whitepath_cons : forall (x:vertex) (x':vertex) (y:vertex)
  (l:(list vertex)) (v:(set vertex)), (~ (mem x v)) -> ((edge x x') ->
  ((whitepath x' l y v) -> (whitepath x (Init.Datatypes.cons x l) y v))).

Axiom path_split_last_occ : forall (x:vertex) (z:vertex) (l1:(list vertex))
  (l2:(list vertex)) (y:vertex), (path x
  (Init.Datatypes.app l1 (Init.Datatypes.cons y l2)) z) -> ((~ (y = z)) ->
  exists l3:(list vertex), exists l4:(list vertex),
  ((Init.Datatypes.app l1 (Init.Datatypes.cons y l2)) = (Init.Datatypes.app l3 (Init.Datatypes.cons y l4))) /\
  ~ (list.Mem.mem y l4)).

Axiom whitepath_split_last_occ : forall (x:vertex) (z:vertex)
  (l1:(list vertex)) (l2:(list vertex)) (y:vertex) (v:(set vertex)),
  (whitepath x (Init.Datatypes.app l1 (Init.Datatypes.cons y l2)) z v) ->
  ((~ (y = z)) -> exists l:(list vertex), (whitepath y
  (Init.Datatypes.cons y l) z v) /\ ~ (list.Mem.mem y l)).

Axiom whitepath_abs : forall (x:vertex) (z:vertex) (l:(list vertex)) (v:(set
  vertex)), (whitepath x (Init.Datatypes.cons x l) z v) -> ((~ (x = z)) ->
  ((~ (list.Mem.mem x l)) -> exists y:vertex, exists l':(list vertex), (edge
  x y) /\ (whitepath y l' z (add x v)))).

(* Why3 goal *)
Theorem WP_parameter_dfs : forall (r:(list vertex)) (v:(set vertex)),
  ((subset (elements r) vertices) /\ (subset v vertices)) ->
  forall (result:bool), ((result = true) <-> (r = Init.Datatypes.nil)) ->
  ((~ (result = true)) -> forall (r1:(list vertex)), forall (x:vertex),
  match r with
  | Init.Datatypes.nil => False
  | (Init.Datatypes.cons x1 t1) => (x = x1) /\ (r1 = t1)
  end -> ((~ (mem x v)) -> forall (r2:(list vertex)), (infix_eqeq
  (union (elements r1) (successors x)) (elements r2)) -> let o := (add x
  v) in (((subset (elements r2) vertices) /\ (subset o vertices)) ->
  forall (v':(set vertex)), ((subset o v') /\ ((subset v' vertices) /\
  ((subset o v') /\ forall (z:vertex) (y:vertex) (l:(list vertex)),
  (list.Mem.mem y r2) -> ((whitepath y l z o) -> (mem z (diff v' o)))))) ->
  ((forall (z:vertex) (y:vertex) (l:(list vertex)), (list.Mem.mem y r1) ->
  ((whitepath y l z v) -> ((~ (z = x)) -> ((whitepath y l z (add x v)) \/
  exists x':vertex, exists l':(list vertex), (edge x x') /\ (whitepath x' l'
  z (add x v)))))) -> ((r = (Init.Datatypes.cons x r1)) -> ((mem x (diff v'
  v)) -> ((subset (elements r) (add x (elements r1))) -> forall (z:vertex)
  (y:vertex) (l:(list vertex)), (list.Mem.mem y r) -> ((whitepath y l z v) ->
  (mem z (diff v' v)))))))))).
intros r v (h1,h2) result h3 h4 r1 x h5 h6 r2 h7 o (h8,h9) v'
(h10,(h11,(h12,h13))) h14 h15 h16 h17 z y l h18 h19.

Qed.

